


.code

;#############################################

TCPConnect proc uses esi edi ebx  pPrxoIP:dword, dPort:dword

           LOCAL   lhSokct : dword
           LOCAL   sins    : sockaddr_in
                       
           invoke  socket, 2, 1, 6   
           mov     lhSokct, eax                    
           invoke  gethostbyname, pPrxoIP            
            .if eax == 0
              invoke closesocket, lhSokct  
              jmp    @@Err
           .endif
           mov     eax, [eax+0Ch]
           mov     eax, [eax]
           mov     eax, [eax]             
           mov     sins.sin_addr, eax 
           mov     sins.sin_family, 2                   
           invoke  htons, dPort
           mov     sins.sin_port, ax                                       
           invoke  connect, lhSokct, addr sins, sizeof sockaddr_in
           .if eax != 0                            
              xor   eax, eax
              jmp   @@Err
           .else
              mov    eax, lhSokct   
           .endif           
@@Err:
           ret
           
TCPConnect  endp  


;#############################################

PingHost proc uses esi edi ebx pPrxoIP:dword, dPort:dword

      LOCAL   ovrlp        : SMBWSAOVERLAPPED 
      LOCAL   options      : dword
      LOCAL   ddsinsx      : sockaddr_in
      LOCAL   ddsins       : sockaddr_in
      LOCAL   traddr       : sockaddr_in
      LOCAL   lpvOutBuffer : dword
      LOCAL   hevn         : dword
      LOCAL   resultr      : dword
      LOCAL   bBytesReturn : dword
      LOCAL   bufft[100]   : byte
      LOCAL   ThreadId     : dword

      invoke  socket, AF_INET, SOCK_STREAM, IPPROTO_TCP
      mov     ebx, eax
      mov     resultr, -1
;-
      invoke  memset, addr ddsinsx, 0, sizeof sockaddr_in
      mov     ddsinsx.sin_family, 2
      invoke  bind, ebx, addr ddsinsx, sizeof sockaddr_in 
      mov     lpvOutBuffer, 0        
      invoke  WSAIoctl, ebx, SIO_GET_EXTENSION_FUNCTION_POINTER, addr TCPdrvGUID, 10h, addr lpvOutBuffer, 4,addr bBytesReturn, 0,0  
      .if lpvOutBuffer != 0
         mov     ddsins.sin_family, 2                             
         mov     eax, pPrxoIP
         mov     ddsins.sin_addr, eax                                                                                    
         invoke  htons, dPort
         mov     ddsins.sin_port, ax          
;-
         invoke  memset, addr ovrlp, 0, sizeof SMBWSAOVERLAPPED
         invoke  WSACreateEvent
         mov     hevn, eax    
         mov     ovrlp.hEvent, eax
         lea     eax, ovrlp
         push    eax
         lea     eax, bBytesReturn
         push    eax     
         push    0  
         push    0                   
         push    1Ch
         lea     eax, ddsins
         push    eax
         push    ebx
         call    lpvOutBuffer
         invoke  GetLastError 
         .if eax == 997   ; WSA_IO_PENDING
            invoke WSAWaitForMultipleEvents, 1, addr hevn, 0, 2000, 1            
            .if  eax == 102h ;  WSA_WAIT_TIMEOUT
               invoke CancelIo, ebx
               invoke DisConnect, ebx                    
            .else
;-
               invoke  CreateThread, 0,0, addr ConnKiller, ebx, 0, addr ThreadId                                  
               invoke  CloseHandle, eax  
;-                                          
               invoke  GetOverlappedResult, ebx, addr ovrlp, addr bBytesReturn, 0                      
               .if eax != 0
                 invoke DisConnect, ebx  
                 mov     resultr, 1
               .endif   
            .endif                                                                              
         .else
            invoke DisConnect, ebx                 
         .endif 
         invoke WSACloseEvent, hevn          
      .endif         
@@Errro:
      mov    eax, resultr
      ret

PingHost endp

;#############################################

ConnKiller  proc uses esi edi ebx pArg:dword
             
      LOCAL   ptabl : dword
                                            
      invoke  CreateEvent, 0,1,0,0
      mov     ebx, eax
      mov     esi, pArg                                                   
            
      invoke  WaitForSingleObject, ebx, 2000
      .if eax == 102h                                           
         invoke DisConnect, esi        
      .endif                         
      invoke  CloseHandle, ebx                    
      mov     eax, 1
      ret

ConnKiller      endp

;#############################################

DisConnect proc  uses esi edi ebx hCokt:dword
         
      LOCAL  lpvOutBuffer : dword
      LOCAL  bBytesReturn : dword
      LOCAL   isrt : linger
         
      mov     bBytesReturn, 0
      mov     lpvOutBuffer, 0
      invoke  WSAIoctl, hCokt, SIO_GET_EXTENSION_FUNCTION_POINTER, addr WSAID_DISCONNECTEX, sizeof GUID, addr lpvOutBuffer, 4,addr bBytesReturn, 0,0  
      .if lpvOutBuffer != 0
         push  0
         push  TF_REUSE_SOCKET
         push  0
         push  hCokt
         call  lpvOutBuffer
      .else
        mov    isrt.l_onoff, 1
        mov    isrt.l_linger, 0
        invoke setsockopt, hCokt,SOL_SOCKET, SO_LINGER, addr isrt, sizeof  linger        
        invoke shutdown, hCokt, 2
        invoke closesocket, hCokt
      .endif 
      ret

DisConnect endp

;#############################################

