KillProcc  proto :dword

SERVICE_CONTROL_SESSIONCHANGE   equ 0eh 
SERVICE_CONTROL_POWEREVENT      equ 0dh
PBT_POWERSETTINGCHANGE          equ  08013h

; WTS_CONNECTSTATE_CLASS 
    WTSActive       equ 0
    WTSConnected    equ 1
    WTSConnectQuery equ 2
    WTSShadow       equ 3
    WTSDisconnected equ 4
    WTSIdle         equ 5
    WTSListen       equ 6
    WTSReset        equ 7
    WTSDown         equ 8
    WTSInit         equ 9



   RegisterPowerSettingNotification  proto :dword, :dword, :dword
   WriteLogFole   proto :dword, :dword
   RstartProcc    proto :dword
   xRunProccess   proto :dword


.data?
         hServiceStatus   dd ?
         g_dwCurrentState dd ?
         hObject          dd ?
         SrvTable         SERVICE_TABLE_ENTRYA <>
         G_dwStop         dd ?
         argv             dd ? 
         argc             dd ?
         szWindDir        db 300 dup (?)  
         modname          db 300 dup (?) 
         
.data
         szInst           db "install",0
         szrem            db "remove",0
         szstop           db "stop",0
         szstrt           db "start",0

         ServiceName      db "LogonSessionDumper",0
         DisplayName      db "LogonSessionDumper",0
         szdebug          db "SeDebugPrivilege",0
         szsbr            db "SeTcbPrivilege",0
         logfil           db "logggg.log",0 
         sztem            db "ExceptionCode - %08X, ExceptionAddress- %08X ",0dh,0ah,0
         szserg           db "RCServer.exe",0
         szDeksp          db "Restarts the server on user change.",0
         
         sztimetempl db "%02d.%02d.%d %02d:%02d:%02d",0 
         
         GUID_CONSOLE_DISPLAY_STATE  GUID <06FE69556h, 0704Ah, 047A0h, <08Fh, 024h, 0C2h, 08Dh, 093h, 06Fh, 0DAh, 047h>>
         
         
                                          
.code

;##############################################

InstallService  proc uses esi edi ebx 
         
         LOCAL  Filename[104h]:byte
         LOCAL  hSCManager : dword
         LOCAL  hSCObject  : dword

                        
         invoke OpenSCManager, 0, 0, 2                 
         mov    hSCManager, eax
         .if eax == 0
             jmp  @@Fin
         .endif 
         invoke GetModuleFileName, 0, addr Filename, 104h  
         
;         invoke CreateService, hSCManager, offset ServiceName, offset DisplayName, 0, 110h, 2, 0, addr Filename, 0, 0, 0, 0,0   
         
         invoke CreateService, hSCManager, offset ServiceName, offset DisplayName, 0F01FFh, 10h, 2, 1, addr Filename, 0, 0, 0, 0,0                          
         mov    hSCObject, eax                        
         .if eax == 0
            jmp  @@F1
         .endif

         invoke ChangeServiceConfig2, hSCObject, 1, addr szDeksp


         invoke CloseServiceHandle, hSCObject                                     
@@F1: 
         invoke CloseServiceHandle, hSCManager
@@Fin:
         ret

InstallService  endp

;######################################################

ServiceStart proc  uses esi edi ebx 

          LOCAL  hService   : dword
          LOCAL  hSCManager : dword
          
          invoke OpenSCManager, 0,0, SC_MANAGER_CONNECT ;0F003Fh
          mov    hSCManager, eax      
         .if eax == 0
             jmp  @@Fin
         .endif 
          invoke OpenService, hSCManager, offset ServiceName, SERVICE_START
          mov    hService, eax   
         .if eax == 0
            jmp  @@F1
         .endif
          invoke StartService, hService, 0, 0                                     
          invoke CloseServiceHandle, hService            
@@F1:   
          invoke CloseServiceHandle, hSCManager
@@Fin:
          ret

ServiceStart  endp

;######################################################

StopService  proc uses esi edi ebx 

         LOCAL  ServiceStatus : SERVICE_STATUS 
         LOCAL  hSCManager    : dword
         LOCAL  hService      : dword
          
         invoke OpenSCManager, 0, 0, SC_MANAGER_CONNECT
         mov    hSCManager, eax           
         .if eax == 0
             jmp  @@Fin
         .endif   
         invoke OpenService, hSCManager, offset ServiceName, SERVICE_STOP         
         mov    hService, eax   
         .if eax == 0
            jmp  @@F1
         .endif
         invoke ControlService, hService, SERVICE_CONTROL_STOP, addr ServiceStatus                                 
         invoke CloseServiceHandle, hService                                   
@@F1:         
         invoke CloseServiceHandle, hSCManager
@@Fin:
         ret

StopService  endp

;######################################################

NotifySCM proc uses esi edi ebx dwStat:dword, dwExCod:dword, dwChPt:dword                              

         LOCAL  ServiceStatus : SERVICE_STATUS
                 
         and    ServiceStatus.dwServiceSpecificExitCode, 0
         mov    ServiceStatus.dwServiceType, SERVICE_WIN32_OWN_PROCESS or SERVICE_INTERACTIVE_PROCESS
         mov    ServiceStatus.dwControlsAccepted, SERVICE_ACCEPT_STOP or SERVICE_ACCEPT_SHUTDOWN
         mov    ServiceStatus.dwWaitHint, 5000
         mov    eax, dwStat
         mov    g_dwCurrentState, eax
         mov    ServiceStatus.dwCurrentState, eax
         mov    eax, dwExCod
         mov    ServiceStatus.dwWin32ExitCode, eax
         mov    eax, dwChPt
         mov    ServiceStatus.dwCheckPoint, eax
         invoke SetServiceStatus, hServiceStatus, addr ServiceStatus             
         ret

NotifySCM endp

;######################################################

RemoveService  proc uses esi edi ebx 

         LOCAL   hService  : dword
         LOCAL   hSCObject : dword 
            
         invoke  OpenSCManager, 0,0,1
         mov     hSCObject, eax     
         .if eax == 0
             jmp  @@Fin
         .endif 
         invoke  OpenService, hSCObject, offset ServiceName, 10000h      
         mov     hService, eax         
         .if eax == 0
            jmp  @@F1
         .endif
         invoke  DeleteService, hService                                                                                                   
         invoke  CloseServiceHandle, hService                                               
@@F1: 
         invoke  CloseServiceHandle, hSCObject
@@Fin:
         ret

RemoveService  endp

;######################################################

ServiceMain  proc uses esi edi ebx 

         LOCAL  Handles[8] : byte 
         LOCAL  ThreadId   : dword
 
 
;         invoke SetThreadExecutionState, 80000002h
         invoke RegisterServiceCtrlHandlerEx, offset ServiceName, offset HandlerProc, 0                  
         mov    hServiceStatus, eax

         invoke RegisterPowerSettingNotification, hServiceStatus, addr GUID_CONSOLE_DISPLAY_STATE, 1
                           
         invoke NotifySCM, SERVICE_START_PENDING, 0, 1            

         invoke CreateEvent, 0, 0, 0, 0 
         mov    hObject, eax                 

         mov    G_dwStop, 0

         invoke NotifySCM, SERVICE_START_PENDING, 0, 2
         invoke CreateThread, 0, 0, addr SessionSwither, 0, 1, addr ThreadId  
         mov    edi, eax

         invoke NotifySCM, SERVICE_RUNNING, 0,0
         mov    eax, hObject
         lea    edx, Handles   
         mov    [edx+4], eax
         mov    [edx], edi           

         invoke WaitForMultipleObjects, 2, addr Handles, 0, -1

         invoke NotifySCM, SERVICE_RUNNING, 0,0                                             
         invoke CloseHandle, hObject
         invoke CloseHandle, edi
         ret

ServiceMain     endp

;######################################################

HandlerProc proc uses esi edi ebx dwControl:dword, dwEventType:dword, lpEventData:dword, lpContext:dword

         LOCAL  pBytesReturned : dword
         LOCAL  ppBuffer       : dword
         LOCAL  logbuf[200]    : byte


         .if dwControl == SERVICE_CONTROL_INTERROGATE

            invoke  NotifySCM, g_dwCurrentState, 0, 0
         
         .elseif dwControl == SERVICE_CONTROL_STOP                       

            invoke NotifySCM, 3, 0, 1                    
            mov    G_dwStop, 1
            invoke SetEvent, hObject               
            invoke NotifySCM, 1, 0, 0
                    
         .elseif dwControl == SERVICE_CONTROL_POWEREVENT                     

            .if dwEventType ==  PBT_POWERSETTINGCHANGE

               mov  edi, lpEventData
               invoke memcmp, addr (POWERBROADCAST_SETTING ptr [edi]).PowerSetting, addr GUID_CONSOLE_DISPLAY_STATE, 16                     
               .if eax == 0     
                 

               .endif                                 
            .endif                                            

         .elseif dwControl == 129  
            invoke RstartProcc, addr szserg         
        ;    invoke WriteLogFole, addr szserg, eax
         
         .endif                    
         ret

HandlerProc endp

;######################################################

WriteFileData proc  uses edi esi ebx lpFeileName:dword, pBuffe:dword, bfsize:dword
                                     
      LOCAL  retVal   : dword
      LOCAL  hzObject : dword
                                
      mov     retVal, -1
      invoke  CreateFileA, lpFeileName, 40000000h, 3, 0, 4, 80h, 0
      .if eax != -1                                  
         mov     hzObject, eax  
         invoke  SetFilePointer, hzObject, 0, 0, FILE_END
         invoke  WriteFile, hzObject, pBuffe, bfsize, addr retVal, 0
         invoke  CloseHandle, hzObject         
      .endif                                                       
      mov  eax, retVal
      ret

WriteFileData endp

;####################################################

twvpwb  db "%s %d",10, 13, 0
loffile db "c:\Servicelog.txt",0
WriteLogFole proc uses esi edi ebx parg:dword, psrtt:dword
      
      LOCAL  Bitru[100h]:byte
                  

      invoke  wsprintfA, addr Bitru, addr twvpwb, parg, psrtt
      invoke  WriteFileData, addr loffile, addr Bitru,  eax
      ret

WriteLogFole endp

;##############################################