

; IID_IActiveDesktop  "f490eb00-1240-11d1-9888-006097deacf9"

IActiveDesktop struct
    IActiveDesktop_QueryInterface           comethod3 ? ;0
    IActiveDesktop_AddRef                   comethod1 ? ;4
    IActiveDesktop_Release                  comethod1 ? ;8        
    IActiveDesktop_ApplyChanges             comethod2 ? ;c 
    IActiveDesktop_GetWallpaper             comethod4 ? ;10
    IActiveDesktop_SetWallpaper             comethod3 ? ;14 
    IActiveDesktop_GetWallpaperOptions      comethod3 ? ;18 
    IActiveDesktop_SetWallpaperOptions      comethod3 ? ;1c 
    IActiveDesktop_GetPattern               comethod4 ? ;20
    IActiveDesktop_SetPattern               comethod3 ? ;24
    IActiveDesktop_GetDesktopItemOptions    comethod3 ? ;28
    IActiveDesktop_SetDesktopItemOptions    comethod3 ? ;2c
    IActiveDesktop_AddDesktopItem           comethod3 ? ;30
    IActiveDesktop_AddDesktopItemWithUI     comethod4 ? ;34
    IActiveDesktop_ModifyDesktopItem        comethod3 ? ;38
    IActiveDesktop_RemoveDesktopItem        comethod3 ? ;3c
    IActiveDesktop_GetDesktopItemCount      comethod3 ? ;40
    IActiveDesktop_GetDesktopItem           comethod4 ? ;44
    IActiveDesktop_GetDesktopItemByID       comethod4 ? ;48
    IActiveDesktop_GenerateDesktopItemHtml  comethod4 ? ;4c
    IActiveDesktop_AddUrl                   comethod5 ? ;50
    IActiveDesktop_GetDesktopItemBySource   comethod4 ? ;54
IActiveDesktop ends

WALLPAPEROPT struct
  dwSize   dd ?
  dwStyle  dd ?
WALLPAPEROPT ends




COMPSTATEINFO struct
    dwSize       dd ? ;    Size of this structure.
    iLeft        dd ? ;    Left of the top-left corner in screen co-ordinates.
    iTop         dd ? ;    Top of top-left corner in screen co-ordinates.
    dwWidth      dd ? ;    Width in pixels.
    dwHeight     dd ? ;    Height in pixels.
    dwItemState  dd ? ;    State of the component (full-screen mode or split-screen or normal state.
COMPSTATEINFO ends





COMPONENT_TOP equ  03fffffffh  ; izOrder value meaning component is at the top


; iCompType values
COMP_TYPE_HTMLDOC   equ    0
COMP_TYPE_PICTURE   equ    1
COMP_TYPE_WEBSITE   equ    2
COMP_TYPE_CONTROL   equ    3
COMP_TYPE_CFHTML    equ    4
COMP_TYPE_MAX       equ    4


; Flags for IActiveDesktop::ApplyChanges()
AD_APPLY_SAVE             equ 000000001h
AD_APPLY_HTMLGEN          equ 000000002h
AD_APPLY_REFRESH          equ 000000004h
AD_APPLY_ALL              equ AD_APPLY_SAVE or AD_APPLY_HTMLGEN or AD_APPLY_REFRESH
AD_APPLY_FORCE            equ 000000008h
AD_APPLY_BUFFERED_REFRESH equ 000000010h
AD_APPLY_DYNAMICREFRESH   equ 000000020h




; Flags for IActiveDesktop::GetWallpaperOptions()
;           IActiveDesktop::SetWallpaperOptions()
 WPSTYLE_CENTER     equ  0
 WPSTYLE_TILE       equ  1
 WPSTYLE_STRETCH    equ  2
 WPSTYLE_SPAN       equ  5
 WPSTYLE_KEEPASPECT equ  3
 WPSTYLE_CROPTOFIT  equ  4


; Flags for IActiveDesktop::ModifyComponent()

 COMP_ELEM_TYPE          equ 000000001h
 COMP_ELEM_CHECKED       equ 000000002h
 COMP_ELEM_DIRTY         equ 000000004h
 COMP_ELEM_NOSCROLL      equ 000000008h
 COMP_ELEM_POS_LEFT      equ 000000010h
 COMP_ELEM_POS_TOP       equ 000000020h
 COMP_ELEM_SIZE_WIDTH    equ 000000040h
 COMP_ELEM_SIZE_HEIGHT   equ 000000080h
 COMP_ELEM_POS_ZINDEX    equ 000000100h
 COMP_ELEM_SOURCE        equ 000000200h
 COMP_ELEM_FRIENDLYNAME  equ 000000400h
 COMP_ELEM_SUBSCRIBEDURL equ 000000800h
 COMP_ELEM_ORIGINAL_CSI  equ 000001000h
 COMP_ELEM_RESTORED_CSI  equ 000002000h
 COMP_ELEM_CURITEMSTATE  equ 000004000h

; Flags for IActiveDesktop::AddDesktopItemWithUI()

    DTI_ADDUI_DEFAULT        equ 000000000h
    DTI_ADDUI_DISPSUBWIZARD  equ 000000001h
    DTI_ADDUI_POSITIONITEM   equ 000000002h

; Flags for IActiveDesktop::AddUrl()
 ADDURL_SILENT        equ   0001



; Default positions for ADI
 COMPONENT_DEFAULT_LEFT  equ  0FFFFh
 COMPONENT_DEFAULT_TOP   equ  0FFFFh

   

   
   

    
    
    
    
    